Color modes

Vue Bootstrap 5 Color modes

MDB Vue now supports color modes, or themes, as of v7.0.0. Explore our default light color mode and the new dark mode, or create your own using our styles as your template.


Dark mode

MDB Vue now supports color modes, starting with dark mode! With v7.0.0 you can implement your own color mode toggler (see below for an example) and apply the different color modes as you see fit. We support a light mode (default) and now dark mode. Color modes can be toggled globally on the <html> element, or on specific components and elements, thanks to the data-mdb-theme attribute.

Alternatively, you can also switch to a media query implementation thanks to our color mode mixin—see the usage section for details. Heads up though—this eliminates your ability to change themes on a per-component basis as shown below.


Enable color mode for a specific component

You can also change the mode to dark only for the specific component. For example, to change the color mode of a card, add data-mdb-theme="light" or data-mdb-theme="dark" to the div with .card class. Now, no matter the global color mode, these cards will display with the specified theme value.

Card title

Some quick example text to build on the card title and make up the bulk of the card's content.

Card title

Some quick example text to build on the card title and make up the bulk of the card's content.

        
            
                <template>
                  <MDBRow class="gx-lg-5">
                    <MDBCol lg="6">
                      <MDBCard>
                        <MDBCardBody>
                          <MDBCardTitle>Card title</MDBCardTitle>
                          <MDBCardText>
                            Some quick example text to build on the card title and make up
                            the bulk of the card's content.
                          </MDBCardText>
                          <MDBBtn color="primary">Button</MDBBtn>
                        </MDBCardBody>
                      </MDBCard>
                    </MDBCol>
                    <MDBCol lg="6">
                      <MDBCard data-mdb-theme="dark">
                        <MDBCardBody>
                          <MDBCardTitle>Card title</MDBCardTitle>
                          <MDBCardText>
                            Some quick example text to build on the card title and make up
                            the bulk of the card's content.
                          </MDBCardText>
                          <MDBBtn color="primary">Button</MDBBtn>
                        </MDBCardBody>
                      </MDBCard>
                    </MDBCol>
                  </MDBRow>
                </template>
                
        
    
        
            
                <script>
                  import { MDBCard, MDBCardBody, MDBCardTitle, MDBCardText, MDBBtn, MDBRow, MDBCol } from "mdb-vue-ui-kit";
                  export default {
                    components: {
                      MDBCard,
                      MDBCardBody,
                      MDBCardTitle,
                      MDBCardText,
                      MDBBtn,
                      MDBRow,
                      MDBCol
                    }
                  };
                </script>
                
        
    
        
            
                <script setup lang="ts">
                  import { MDBCard, MDBCardBody, MDBCardTitle, MDBCardText, MDBBtn, MDBRow, MDBCol } from "mdb-vue-ui-kit";
                </script>
                
        
    

How it works

  • As shown above, color mode styles are controlled by the data-mdb-theme attribute. This attribute can be applied to the <html> element, or to any other element or MDB component. If applied to the <html> element, it will apply to everything. If applied to a component or element, it will be scoped to that specific component or element.

  • For each color mode you wish to support, you'll need to add new overrides for the shared global CSS variables. We do this already in our _root.scss stylesheet for dark mode, with light mode being the default values. In writing color mode specific styles, use the mixin:

            
                
            // Color mode variables in _root.scss
            @include color-mode(dark) {
              // CSS variable overrides here...
            }
            
            
        
  • We use a custom _variables-dark.scss to power those shared global CSS variable overrides for dark mode. This file isn’t required for your own custom color modes, but it’s required for our dark mode for two reasons. First, it’s better to have a single place to reset global colors. Second, some Sass variables had to be overridden for background images embedded in our CSS for accordions, form components, and more.


Usage

Enable dark mode

Enable the built in dark color mode across your entire project by adding the data-mdb-theme="dark" attribute to the <html> element. This will apply the dark color mode to all components and elements, other than those with a specific data-mdb-theme attribute applied.

        
            
        <!DOCTYPE html>
        <html lang="en" data-mdb-theme="dark">
          <head>
            <meta charset="UTF-8" />
            <link rel="icon" type="image/svg+xml" href="/vite.svg" />
            <meta name="viewport" content="width=device-width, initial-scale=1.0" />
            <link
              href="https://fonts.googleapis.com/css?family=Roboto:300,400,500,700,900&display=swap"
              rel="stylesheet"
            />
            <link
              href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.0.0/css/all.min.css"
              rel="stylesheet"
            />

            <title>MDBootstrap demo</title>
          </head>
          <body>
            <div id="app"></div>
            <script type="module" src="/src/main.ts"></script>
          </body>
        </html>
        
        
    

Building with Sass

Our new dark mode option is available to use for all users of MDBootstrap, but it’s controlled via data attributes instead of media queries and does not automatically toggle your project’s color mode. You can disable our dark mode entirely via Sass by changing $enable-dark-mode to false.

We use a custom Sass mixin, color-mode(), to help you control how color modes are applied. By default, we use a data attribute approach, allowing you to create more user-friendly experiences where your visitors can choose to have an automatic dark mode or control their preference (like in our own docs here). This is also an easy and scalable way to add different themes and more custom color modes beyond light and dark.

In case you want to use media queries and only make color modes automatic, you can change the mixin’s default type via Sass variable. Consider the following snippet and its compiled CSS output.

        
            
      $color-mode-type: data;

      @include color-mode(dark) {
        .element {
          color: var(--mdb-primary-text-emphasis);
          background-color: var(--mdb-primary-bg-subtle);
        }
      }
      
        
    

Outputs to:

        
            
      [data-mdb-theme=dark] .element {
        color: var(--mdb-primary-text-emphasis);
        background-color: var(--mdb-primary-bg-subtle);
      }
      
        
    

And when setting to media-query:

        
            
      $color-mode-type: media-query;

      @include color-mode(dark) {
        .element {
          color: var(--mdb-primary-text-emphasis);
          background-color: var(--mdb-primary-bg-subtle);
        }
      }
      
        
    

Outputs to:

        
            
      @media (prefers-color-scheme: dark) {
        .element {
          color: var(--mdb-primary-text-emphasis);
          background-color: var(--mdb-primary-bg-subtle);
        }
      }
      
        
    

Custom color modes

While the primary use case for color modes is light and dark mode, custom color modes are also possible. Create your own data-mdb-theme selector with a custom value as the name of your color mode, then modify our Sass and CSS variables as needed. We opted to create a separate _variables-dark.scss stylesheet to house Bootstrap’s dark mode specific Sass variables, but that’s not required for you.

For example, you can create a “blue theme” with the selector data-mdb-theme="blue". In your custom Sass or CSS file, add the new selector and override any global or component CSS variables as needed. If you’re using Sass, you can also use Sass’s functions within your CSS variable overrides.

        
            
    [data-mdb-theme="blue"] {
      --mdb-body-color: var(--mdb-white);
      --mdb-body-color-rgb: #{to-rgb($white)};
      --mdb-body-bg: var(--mdb-blue);
      --mdb-body-bg-rgb: #{to-rgb($blue)};
      --mdb-tertiary-bg: #{$blue-600};
  
      .dropdown-menu {
        --mdb-dropdown-bg: #{mix($blue-500, $blue-600)};
        --mdb-dropdown-link-active-bg: #{$blue-700};
      }
  
      .btn-outline-secondary {
        --mdb-btn-bg: #{mix($gray-600, $blue-400, .5)};
        --mdb-btn-color: var(--mdb-white);
        --mdb-btn-border-color: var(--mdb-white);
        --mdb-btn-hover-bg: #{darken(mix($gray-600, $blue-400, .5), 5%)};
        --mdb-btn-hover-border-color: #{rgba($white, .25)};
        --mdb-btn-active-bg: #{darken(mix($gray-600, $blue-400, .5), 10%)};
        --mdb-btn-active-border-color: #{rgba($white, .5)};
        --mdb-btn-focus-border-color: #{rgba($white, .5)};
        --mdb-btn-focus-box-shadow: 0 0 0 .25rem rgba(255, 255, 255, .2);
        --mdb-btn-hover-color: var(--mdb-white);
        --mdb-btn-outline-focus-border-color: #{rgba($white, .5)};
        --mdb-btn-active-color: #{rgba($white, .5)};
      }
    }
    
        
    
Example blue theme

Some paragraph text to show how the blue theme might look with written copy.


        
            
        <div data-mdb-theme="blue">
          ...
        </div>
        
        
    

JavaScript

To allow visitors or users to toggle color modes, you'll need to create a toggle element to control the data-mdb-theme attribute on the root element, <html>. We've built a toggler in our documentation that initially defers to a user's current system color mode, but provides an option to override that and pick a specific color mode.

Here's a vue version of code we used in own documentation navbar. You can see how it's implemented using our own vue components. It is suggested to include the component in the main App.vue file.

        
            
        <template>
          <div
            class="position-fixed bottom-0 end-0 border border-secondary card p-3 m-3"
          >
            <div class="nav-item align-items-center d-flex">
              <MDBIcon fas icon="sun" />
              <div class="ms-2">
                <MDBSwitch v-model="isDarkMode" />
              </div>
              <MDBIcon fas icon="moon" />
            </div>
          </div>
        </template>
        
        
    
        
            
        <script>
          import { ref, watch, onMounted } from "vue";
          import { MDBIcon, MDBSwitch } from "../index.free";

          export default {
            name: "ThemeSwitcher",
            components: { MDBIcon, MDBSwitch },
            setup() {
              const isDarkMode = ref(false);

              const toggleTheme = () => {
                if (typeof document === "undefined") {
                  return;
                }

                const theme = isDarkMode.value ? "dark" : "light";

                document.documentElement.setAttribute("data-mdb-theme", theme);
                localStorage.theme = theme;
              };

              watch(isDarkMode, toggleTheme);

              const addEventListeners = () => {
                if (typeof document === "undefined") {
                  return;
                }

                document.addEventListener("keydown", (e) => {
                  if (e.shiftKey && e.key === "D") {
                    isDarkMode.value = !isDarkMode.value;
                  }
                });
              };

              const setSystemTheme = () => {
                if (typeof window === "undefined") {
                  return;
                }

                const isSystemThemeSetToDark = window.matchMedia(
                  "(prefers-color-scheme: dark)"
                ).matches;

                // set toggler position based on system theme
                if (isSystemThemeSetToDark) {
                  isDarkMode.value = true;
                }
              };

              onMounted(() => {
                if (typeof document === "undefined") {
                  return;
                }
                addEventListeners();

                if (!("theme" in localStorage)) {
                  setSystemTheme();
                  return;
                }

                isDarkMode.value = localStorage.theme === "dark";
              });

              return {
                isDarkMode,
              };
            },
          };
        </script>
        
        
    
        
            
       <script setup lang="ts">
          import { ref, watch, onMounted } from "vue";
          import { MDBIcon, MDBSwitch } from "../index.free";

          const isDarkMode = ref(false);

          const toggleTheme = () => {
            if (typeof document === "undefined") {
              return;
            }

            const theme = isDarkMode.value ? "dark" : "light";

            document.documentElement.setAttribute("data-mdb-theme", theme);
            localStorage.theme = theme;
          };

          watch(isDarkMode, toggleTheme);

          const addEventListeners = () => {
            if (typeof document === "undefined") {
              return;
            }

            document.addEventListener("keydown", (e) => {
              if (e.shiftKey && e.key === "D") {
                isDarkMode.value = !isDarkMode.value;
              }
            });
          };

          const setSystemTheme = () => {
            if (typeof window === "undefined") {
              return;
            }

            const isSystemThemeSetToDark = window.matchMedia(
              "(prefers-color-scheme: dark)"
            ).matches;

            // set toggler position based on system theme
            if (isSystemThemeSetToDark) {
              isDarkMode.value = true;
            }
          };

          onMounted(() => {
            if (typeof document === "undefined") {
              return;
            }
            addEventListeners();

            if (!("theme" in localStorage)) {
              setSystemTheme();
              return;
            }

            isDarkMode.value = localStorage.theme === "dark";
          });
          </script>
        
        
    

Adding theme colors

Adding a new color in $theme-colors is not enough for some of our components like alerts and list groups. New colors must also be defined in $theme-colors-text, $theme-colors-bg-subtle, and $theme-colors-border-subtle for light theme; but also in $theme-colors-text-dark, $theme-colors-bg-subtle-dark, and $theme-colors-border-subtle-dark for dark theme.

This is a manual process because Sass cannot generate its own Sass variables from an existing variable or map. In future versions, we’ll revisit this setup to reduce the duplication.

        
            
    // Required
    @import "functions";
    @import "variables";
    @import "variables-dark";
    
    // Add a custom color to $theme-colors
    $custom-colors: (
      "custom-color": #712cf9
    );
    $theme-colors: map-merge($theme-colors, $custom-colors);
    
    @import "maps";
    @import "mixins";
    @import "utilities";
    
    // Add a custom color to new theme maps
    
    // Light mode
    $custom-colors-text: ("custom-color": #712cf9);
    $custom-colors-bg-subtle: ("custom-color": #e1d2fe);
    $custom-colors-border-subtle: ("custom-color": #bfa1fc);
    
    $theme-colors-text: map-merge($theme-colors-text, $custom-colors-text);
    $theme-colors-bg-subtle: map-merge($theme-colors-bg-subtle, $custom-colors-bg-subtle);
    $theme-colors-border-subtle: map-merge($theme-colors-border-subtle, $custom-colors-border-subtle);
    
    // Dark mode
    $custom-colors-text-dark: ("custom-color": #e1d2f2);
    $custom-colors-bg-subtle-dark: ("custom-color": #8951fa);
    $custom-colors-border-subtle-dark: ("custom-color": #e1d2f2);
    
    $theme-colors-text-dark: map-merge($theme-colors-text-dark, $custom-colors-text-dark);
    $theme-colors-bg-subtle-dark: map-merge($theme-colors-bg-subtle-dark, $custom-colors-bg-subtle-dark);
    $theme-colors-border-subtle-dark: map-merge($theme-colors-border-subtle-dark, $custom-colors-border-subtle-dark);
    
    // Remainder of MDB imports
    @import "root";
    @import "reboot";
    // etc
    
        
    

GET

UP TO 98% OFF

Check out our bundles and get up to 98% off PRO components.

Color modes - API


CSS variables

Dozens of root level CSS variables are repeated as overrides for dark mode. These are scoped to the color mode selector, which defaults to data-mdb-theme but can be configured to use a prefers-color-scheme media query. Use these variables as a guideline for generating your own new color modes.

        
            
        --#{$prefix}body-color: #{$body-color-dark};
        --#{$prefix}body-color-rgb: #{to-rgb($body-color-dark)};
        --#{$prefix}body-bg: #{$body-bg-dark};
        --#{$prefix}body-bg-rgb: #{to-rgb($body-bg-dark)};
    
        --#{$prefix}emphasis-color: #{$body-emphasis-color-dark};
        --#{$prefix}emphasis-color-rgb: #{to-rgb($body-emphasis-color-dark)};
    
        --#{$prefix}secondary-color: #{$body-secondary-color-dark};
        --#{$prefix}secondary-color-rgb: #{to-rgb($body-secondary-color-dark)};
        --#{$prefix}secondary-bg: #{$body-secondary-bg-dark};
        --#{$prefix}secondary-bg-rgb: #{to-rgb($body-secondary-bg-dark)};
    
        --#{$prefix}tertiary-color: #{$body-tertiary-color-dark};
        --#{$prefix}tertiary-color-rgb: #{to-rgb($body-tertiary-color-dark)};
        --#{$prefix}tertiary-bg: #{$body-tertiary-bg-dark};
        --#{$prefix}tertiary-bg-rgb: #{to-rgb($body-tertiary-bg-dark)};
    
        @each $color, $value in $theme-colors-text-dark {
          --#{$prefix}#{$color}-text-emphasis: #{$value};
        }
    
        @each $color, $value in $theme-colors-bg-subtle-dark {
          --#{$prefix}#{$color}-bg-subtle: #{$value};
        }
    
        @each $color, $value in $theme-colors-border-subtle-dark {
          --#{$prefix}#{$color}-border-subtle: #{$value};
        }
    
        --#{$prefix}heading-color: #{$headings-color-dark};
    
        --#{$prefix}link-color: #{$link-color-dark};
        --#{$prefix}link-hover-color: #{$link-hover-color-dark};
        --#{$prefix}link-color-rgb: #{to-rgb($link-color-dark)};
        --#{$prefix}link-hover-color-rgb: #{to-rgb($link-hover-color-dark)};
    
        --#{$prefix}code-color: #{$code-color-dark};
    
        --#{$prefix}border-color: #{$border-color-dark};
        --#{$prefix}border-color-translucent: #{$border-color-translucent-dark};
    
        --#{$prefix}form-valid-color: #{$form-valid-color-dark};
        --#{$prefix}form-valid-border-color: #{$form-valid-border-color-dark};
        --#{$prefix}form-invalid-color: #{$form-invalid-color-dark};
        --#{$prefix}form-invalid-border-color: #{$form-invalid-border-color-dark};


        --#{$prefix}surface-color: #{$surface-color-dark};
        --#{$prefix}surface-color-rgb: #{to-rgb($surface-color-dark)};
        --#{$prefix}surface-bg: #{$surface-bg-dark};
        --#{$prefix}surface-inverted-color: #{$surface-inverted-color-dark};
        --#{$prefix}surface-inverted-color-rgb: #{to-rgb($surface-inverted-color-dark)};
        --#{$prefix}surface-inverted-bg: #{$surface-inverted-bg-dark};
        --#{$prefix}divider-color: #{$divider-color-dark};
        --#{$prefix}highlight-bg-color: #{$highlight-bg-color-dark};
        --#{$prefix}scrollbar-rail-bg: #{$scrollbar-rail-bg-dark};
        --#{$prefix}scrollbar-thumb-bg: #{$scrollbar-thumb-bg-dark};
        --#{$prefix}picker-header-bg: #{$picker-header-bg-dark};
        --#{$prefix}timepicker-clock-face-bg: #{$timepicker-clock-face-bg-dark};
        --#{$prefix}sidenav-backdrop-opacity: #{$sidenav-backdrop-opacity-dark};
        --#{$prefix}form-control-border-color: #{$form-control-border-color-dark};
        --#{$prefix}form-control-label-color: #{$form-control-label-color-dark};
        --#{$prefix}form-control-disabled-bg: #{$form-control-disabled-bg-dark};
        --#{$prefix}box-shadow-color: #{$box-shadow-color-dark};
        --#{$prefix}box-shadow-color-rgb: #{to-rgb($box-shadow-color-dark)};
        --#{$prefix}stepper-mobile-bg: #{$stepper-mobile-bg-dark};
        
        
        
    

SCSS variables

        
            

        $primary-text-emphasis-dark: tint-color($primary, 20%) !default;
        $secondary-text-emphasis-dark: tint-color($secondary, 60%) !default;
        $success-text-emphasis-dark: tint-color($success, 40%) !default;
        $info-text-emphasis-dark: tint-color($info, 30%) !default;
        $warning-text-emphasis-dark: tint-color($warning, 40%) !default;
        $danger-text-emphasis-dark: tint-color($danger, 20%) !default;
        $light-text-emphasis-dark: $gray-100 !default;
        $dark-text-emphasis-dark: $gray-200 !default;

        $primary-bg-subtle-dark: shade-color($primary, 80%) !default;
        $secondary-bg-subtle-dark: shade-color($secondary, 80%) !default;
        $success-bg-subtle-dark: shade-color($success, 80%) !default;
        $info-bg-subtle-dark: shade-color($info, 80%) !default;
        $warning-bg-subtle-dark: shade-color($warning, 80%) !default;
        $danger-bg-subtle-dark: shade-color($danger, 80%) !default;
        $light-bg-subtle-dark: $gray-800 !default;
        $dark-bg-subtle-dark: $gray-900 !default;

        $primary-border-subtle-dark: shade-color($primary, 40%) !default;
        $secondary-border-subtle-dark: shade-color($secondary, 40%) !default;
        $success-border-subtle-dark: shade-color($success, 40%) !default;
        $info-border-subtle-dark: shade-color($info, 40%) !default;
        $warning-border-subtle-dark: shade-color($warning, 40%) !default;
        $danger-border-subtle-dark: shade-color($danger, 40%) !default;
        $light-border-subtle-dark: $gray-700 !default;
        $dark-border-subtle-dark: $gray-800 !default;

        $body-color-dark: $white !default;
        $body-bg-dark: #303030 !default;
        $body-secondary-bg-dark: $gray-200 !default;
        $border-color-dark: rgba(255, 255, 255, 0.12) !default;
        $border-color-translucent-dark: rgba($white, 0.15) !default;

        $surface-color-dark: $white !default;
        $surface-bg-dark: #424242 !default;
        $surface-inverted-color-dark: $white !default;
        $surface-inverted-bg-dark: #757575 !default;
        $divider-color-dark: rgba(255, 255, 255, 0.12) !default;
        $highlight-bg-color-dark: rgba(255, 255, 255, 0.3) !default;
        $scrollbar-rail-bg-dark: $gray-500 !default;
        $scrollbar-thumb-bg-dark: $gray-200 !default;
        $picker-header-bg-dark: #323232 !default;
        $timepicker-clock-face-bg-dark: $gray-700 !default;
        $sidenav-backdrop-opacity-dark: 0.5 !default;
        $form-control-border-color-dark: rgba(255, 255, 255, 0.7) !default;
        $form-control-label-color-dark: $gray-400 !default;
        $form-control-disabled-bg-dark: $gray-700 !default;
        $box-shadow-color-dark: $black !default;
        $stepper-mobile-bg-dark: $gray-800 !default;

        // Accordion

        $accordion-icon-color-dark: $surface-color-dark !default;
        $accordion-icon-active-color-dark: $primary !default;

        
        
    

Sass mixins

Styles for dark mode, and any custom color modes you create, can be scoped appropriately to the data-mdb-theme attribute selector or media query with the customizable color-mode() mixin. See the Sass usage section in the Overview tab for more details.

        
            

          @mixin color-mode($mode: light, $root: false) {
            @if $color-mode-type == 'media-query' {
              @if $root == true {
                @media (prefers-color-scheme: $mode) {
                  :root {
                    @content;
                  }
                }
              } @else {
                @media (prefers-color-scheme: $mode) {
                  @content;
                }
              }
            } @else {
              [data-mdb-theme='#{$mode}'] {
                @content;
              }
            }
          }

Theme

React Bootstrap 5 Theme

Theming system enables you to customize the appearance of all MDB components.

Appearance customization options enable you to create skins for your Bootstrap 5 project. Use predefined dark theme, light theme or create custom themes.

See an example of a dark-theme created using our theme system.


How to start

Creating a theme requires recompiling the scss styles, for this purpose we recommend using sass compiler

Step 1

Install sass

        
            
            npm i sass
          
        
    

Step 2

Copy scss folder from node_modules/mdb-react-ui-kit/dist

Step 3

Put copied files into the src folder.

Step 4

Create an index.scss file in the scss folder and import MDB Pro scss styles:

        
            
            @import './mdb.pro.scss';;
          
        
    

Step 5

In your root index.js file instead of importing CSS stylesheet:

        
            
            import 'mdb-react-ui-kit/dist/css/mdb.min.css';
          
        
    

Import index.scss file:

        
            
            import './scss/index.scss';
          
        
    

Create a new theme

Creating a new theme requires that you define primary and secondary colors for your application. We prepared functions and mixins that will help you to create a ready to use theme using these colors.

Go to scss folder you copied before, open index.scss file located in src/scss folder and replace the code there with the following code:

        
            
            @import './mdb.pro.scss';

            $my-theme-primary: #9c27b0; // theme primary color, change this value to customize theme
            $my-theme-secondary: #69f0ae; // theme secondary color, change this value to customize theme

            $my-theme: mdb-light-theme($my-theme-primary, $my-theme-secondary); // create the new theme using primary and
            // secondary colors

            // include theme styles
            @include mdb-theme($my-theme);
          
        
    

Light theme

It's possible to create a light theme using mdb-light-theme function. You just need to define primary and secondary colors, all other parameters will be adjusted automatically.

        
            
            @import './mdb.pro.scss';

            $my-theme-primary: #9c27b0; // theme primary color, change this value to customize theme
            $my-theme-secondary: #69f0ae; // theme secondary color, change this value to customize theme

            $my-light-theme: mdb-light-theme($my-theme-primary, $my-theme-secondary); // create the new light theme using
            // primary and secondary colors

            // include theme styles
            @include mdb-theme($my-light-theme);
          
        
    

Dark theme

It's possible to create a dark theme using mdb-dark-theme function. You just need to define primary and secondary colors, all other parameters will be adjusted automatically.

        
            
            @import './mdb.pro.scss';

            $my-theme-primary: #9c27b0; // theme primary color, change this value to customize theme
            $my-theme-secondary: #69f0ae; // theme secondary color, change this value to customize theme

            $my-dark-theme: mdb-dark-theme($my-theme-primary, $my-theme-secondary); // create the new dark theme using
            // primary and secondary colors

            // include theme styles
            @include mdb-theme($my-dark-theme);
          
        
    

Ready-to-use dark skin

For your convenience, we added a ready-to-use dark skin to our UI KIT pro essential and pro advanced. Installation is very easy, because you just need to replace the current mdb.min.css stylesheet path with mdb.dark.min.css. The files are located in the mdb-react-ui-kit/dist/css.

        
            
            import 'mdb-react-ui-kit/dist/css/mdb.dark.min.css';
          
        
    

Skin toggler

It's possible to create a skin toggler. Create a dark theme inside your main scss file, but this time wrap @include rule with any custom class. Then add the button switch to toggle this class for the body element.

        
            
            @import '~mdb-react-ui-kit/src/scss/mdb.pro.scss';

            // DARK SKIN
            $my-theme-primary: #1266f1;
            $my-theme-secondary: #b23cfd;
            $my-dark-theme: mdb-dark-theme($my-theme-primary, $my-theme-secondary);

            .dark {
              @include mdb-theme($my-dark-theme);
            }
          
        
    
        
            
            import React from 'react';
            import { MDBBtn } from 'mdb-react-ui-kit';

            export default function App() {
              const handleClick = () =>{
                document.body.classList.toggle('dark');
              }

              return (
                <MDBBtn onClick={handleClick}>Toggle skin</MDBBtn>
              )
            }
          
        
    
Instead of making changes to the scss file, you can also use compiled css files and switch between <link rel="stylesheet" href="css/mdb.min.css" /> and <link rel="stylesheet" href="css/mdb.dark.min.css" /> after clicking the toggle button.

GET

UP TO 98% OFF

Check out our bundles and get up to 98% off PRO components.

Color modes

Angular Bootstrap 5 Color modes

MDB Angular now supports color modes, or themes, as of v8.0.0. Explore our default light color mode and the new dark mode, or create your own using our styles as your template.


Dark mode

MDB now supports color modes, starting with dark mode! With v8.0.0 you can implement your own color mode toggler (see below for an example) and apply the different color modes as you see fit. We support a light mode (default) and now dark mode. Color modes can be toggled globally on the <html> element, or on specific components and elements, thanks to the data-mdb-theme attribute.

Alternatively, you can also switch to a media query implementation thanks to our color mode mixin—see the usage section for details. Heads up though—this eliminates your ability to change themes on a per-component basis as shown below.


Enable color mode for a specific component

You can also change the mode to dark only for the specific component. For example, to change the color mode of a card, add data-mdb-theme="light" or data-mdb-theme="dark" to the div with .card class. Now, no matter the global color mode, these cards will display with the specified theme value.

Card title

Some quick example text to build on the card title and make up the bulk of the card's content.

Card title

Some quick example text to build on the card title and make up the bulk of the card's content.

        
            
      
                  <div class="row gx-lg-5">
      
                    <div class="col-lg-6 mb-5 mb-lg-0">
              
                      <div class="card" data-mdb-theme="light">
                        <div class="card-body">
                          <h5 class="card-title">Card title</h5>
                          <p class="card-text">Some quick example text to build on the card title and make up the bulk of the card's content.</p>
                          <button type="button" class="btn btn-primary" mdbRipple>Button</button>
                        </div>
                      </div>
                  
                    </div>
                  
                    <div class="col-lg-6 mb-5 mb-lg-0">
              
                      <div class="card" data-mdb-theme="dark">
                        <div class="card-body">
                          <h5 class="card-title">Card title</h5>
                          <p class="card-text">Some quick example text to build on the card title and make up the bulk of the card's content.</p>
                          <button type="button" class="btn btn-primary" mdbRipple>Button</button>
                        </div>
                      </div>
                      
                    </div>
                  
                  </div>
      
                  
        
    

How it works

  • As shown above, color mode styles are controlled by the data-mdb-theme attribute. This attribute can be applied to the <html> element, or to any other element or MDB component. If applied to the <html> element, it will apply to everything. If applied to a component or element, it will be scoped to that specific component or element.

  • For each color mode you wish to support, you’ll need to add new overrides for the shared global CSS variables. We do this already in our _root.scss stylesheet for dark mode, with light mode being the default values. In writing color mode specific styles, use the mixin:

            
                
              // Color mode variables in _root.scss
              @include color-mode(dark) {
                // CSS variable overrides here...
              }
              
            
        
  • We use a custom _variables-dark.scss to power those shared global CSS variable overrides for dark mode. This file isn’t required for your own custom color modes, but it’s required for our dark mode for two reasons. First, it’s better to have a single place to reset global colors. Second, some Sass variables had to be overridden for background images embedded in our CSS for accordions, form components, and more.


Usage

Enable dark mode

Enable the built in dark color mode across your entire project by adding the data-mdb-theme="dark" attribute to the <html> element. This will apply the dark color mode to all components and elements, other than those with a specific data-mdb-theme attribute applied.

        
            
            <!doctype html>
            <html lang="en" data-mdb-theme="dark">
            <head>
              <meta charset="utf-8">
              <title>MDB Angular Demo</title>
              <base href="/">
              <meta name="viewport" content="width=device-width, initial-scale=1">
              <link rel="icon" type="image/x-icon" href="favicon.ico">
              <link href="https://fonts.googleapis.com/css?family=Roboto:300,400,500,600&display=swap" rel="stylesheet">
            </head>
            <body>
              <app-root></app-root>
            </body>
            </html>
          
        
    

Building with Sass

Our new dark mode option is available to use for all users of MDBootstrap, but it’s controlled via data attributes instead of media queries and does not automatically toggle your project’s color mode. You can disable our dark mode entirely via Sass by changing $enable-dark-mode to false.

We use a custom Sass mixin, color-mode(), to help you control how color modes are applied. By default, we use a data attribute approach, allowing you to create more user-friendly experiences where your visitors can choose to have an automatic dark mode or control their preference (like in our own docs here). This is also an easy and scalable way to add different themes and more custom color modes beyond light and dark.

In case you want to use media queries and only make color modes automatic, you can change the mixin’s default type via Sass variable. Consider the following snippet and its compiled CSS output.

        
            
        $color-mode-type: data;
  
        @include color-mode(dark) {
          .element {
            color: var(--mdb-primary-text-emphasis);
            background-color: var(--mdb-primary-bg-subtle);
          }
        }
        
        
    

Outputs to:

        
            
        [data-mdb-theme=dark] .element {
          color: var(--mdb-primary-text-emphasis);
          background-color: var(--mdb-primary-bg-subtle);
        }
        
        
    

And when setting to media-query:

        
            
        $color-mode-type: media-query;
  
        @include color-mode(dark) {
          .element {
            color: var(--mdb-primary-text-emphasis);
            background-color: var(--mdb-primary-bg-subtle);
          }
        }
        
        
    

Outputs to:

        
            
        @media (prefers-color-scheme: dark) {
          .element {
            color: var(--mdb-primary-text-emphasis);
            background-color: var(--mdb-primary-bg-subtle);
          }
        }
        
        
    

Custom color modes

While the primary use case for color modes is light and dark mode, custom color modes are also possible. Create your own data-mdb-theme selector with a custom value as the name of your color mode, then modify our Sass and CSS variables as needed. We opted to create a separate _variables-dark.scss stylesheet to house Bootstrap’s dark mode specific Sass variables, but that’s not required for you.

For example, you can create a “blue theme” with the selector data-mdb-theme="blue". In your custom Sass or CSS file, add the new selector and override any global or component CSS variables as needed. If you’re using Sass, you can also use Sass’s functions within your CSS variable overrides.

        
            
      [data-mdb-theme="blue"] {
        --mdb-body-color: var(--mdb-white);
        --mdb-body-color-rgb: #{to-rgb($white)};
        --mdb-body-bg: var(--mdb-blue);
        --mdb-body-bg-rgb: #{to-rgb($blue)};
        --mdb-tertiary-bg: #{$blue-600};
    
        .dropdown-menu {
          --mdb-dropdown-bg: #{mix($blue-500, $blue-600)};
          --mdb-dropdown-link-active-bg: #{$blue-700};
        }
    
        .btn-outline-secondary {
          --mdb-btn-bg: #{mix($gray-600, $blue-400, .5)};
          --mdb-btn-color: var(--mdb-white);
          --mdb-btn-border-color: var(--mdb-white);
          --mdb-btn-hover-bg: #{darken(mix($gray-600, $blue-400, .5), 5%)};
          --mdb-btn-hover-border-color: #{rgba($white, .25)};
          --mdb-btn-active-bg: #{darken(mix($gray-600, $blue-400, .5), 10%)};
          --mdb-btn-active-border-color: #{rgba($white, .5)};
          --mdb-btn-focus-border-color: #{rgba($white, .5)};
          --mdb-btn-focus-box-shadow: 0 0 0 .25rem rgba(255, 255, 255, .2);
          --mdb-btn-hover-color: var(--mdb-white);
          --mdb-btn-outline-focus-border-color: #{rgba($white, .5)};
          --mdb-btn-active-color: #{rgba($white, .5)};
        }
      }
      
        
    
Example blue theme

Some paragraph text to show how the blue theme might look with written copy.


        
            
          <div data-mdb-theme="blue">
            ...
          </div>
          
        
    

Color mode toggle

To allow visitors or users to toggle color modes, you’ll need to create a toggle element to control the data-mdb-theme attribute on the root element, <html>. We’ve built a toggler in our documentation that initially defers to a user’s current system color mode, but provides an option to override that and pick a specific color mode.

Here’s a simplified version of code we used in own documentation navbar. You can see how it’s implemented using HTML and CSS from our own components. It is suggested to include the JavaScript at the top of your page to reduce potential screen flickering during reloading of your site.

        
            
            <div mdbDropdown class="dropdown ms-auto">
              <button
                class="border-0 bg-transparent"
                type="button"
                id="dropdownMenuButton"
                aria-expanded="false"
                mdbDropdownToggle
              >
                <i
                  class="fas me-2 fs-5"
                  [ngClass]="{
                    'fa-sun': currentThemeSig() === MdbThemeEnum.LIGHT,
                    'fa-moon': currentThemeSig() === MdbThemeEnum.DARK
                  }"
                ></i>
              </button>
              <ul mdbDropdownMenu class="dropdown-menu dropdown-menu-end" style="min-width: 8rem">
                <li>
                  <button
                    type="button"
                    data-theme="light"
                    class="dropdown-item d-flex align-items-center"
                    (click)="currentThemeSig.set(MdbThemeEnum.LIGHT)"
                  >
                    <i class="fas fa-sun me-2"></i>Light
                  </button>
                </li>
                <li>
                  <button
                    type="button"
                    data-theme="dark"
                    class="dropdown-item d-flex align-items-center"
                    (click)="currentThemeSig.set(MdbThemeEnum.DARK)"
                  >
                    <i class="fas fa-moon me-2"></i>
                    Dark
                  </button>
                </li>
                <li>
                  <button
                    type="button"
                    data-theme="system"
                    class="dropdown-item d-flex align-items-center"
                    (click)="currentThemeSig.set(MdbThemeEnum.SYSTEM)"
                  >
                    <i class="fas fa-laptop me-2"></i>
                    System
                  </button>
                </li>
              </ul>
            </div>
          
        
    

Place the code from the snippet below in JS file that you will link on every page at the end of a <body> tag. This code will check your system default settings and set theme based on that.

        
            
          import { Component, HostListener, effect, signal } from '@angular/core';

          enum MdbTheme {
            DARK = 'dark',
            LIGHT = 'light',
            SYSTEM = 'system',
          }
          
          @Component({
            selector: 'app-root',
            templateUrl: './app.component.html',
          })
          export class AppComponent {
            MdbThemeEnum = MdbTheme;
            currentThemeSig = signal<MdbTheme>(localStorage.theme ? localStorage.theme : MdbTheme.SYSTEM);
          
            constructor() {
              effect(
                () => {
                  const prefersDark = window.matchMedia('(prefers-color-scheme: dark)').matches;
          
                  const newThemeValue =
                    this.currentThemeSig() === MdbTheme.SYSTEM
                      ? prefersDark
                        ? MdbTheme.DARK
                        : MdbTheme.LIGHT
                      : this.currentThemeSig();
          
                  document.documentElement.setAttribute('data-mdb-theme', newThemeValue);
                  this.currentThemeSig.set(newThemeValue);
          
                  if (this.currentThemeSig() !== MdbTheme.SYSTEM) {
                    localStorage.theme = newThemeValue;
                  }
                },
                { allowSignalWrites: true }
              );
            }
          
            @HostListener('document:keydown.shift.d')
            handleShiftDKey() {
              this.currentThemeSig.set(
                this.currentThemeSig() === MdbTheme.LIGHT ? MdbTheme.DARK : MdbTheme.LIGHT
              );
            }
          }
        
        
    

Adding theme colors

Adding a new color in $theme-colors is not enough for some of our components like alerts and list groups. New colors must also be defined in $theme-colors-text, $theme-colors-bg-subtle, and $theme-colors-border-subtle for light theme; but also in $theme-colors-text-dark, $theme-colors-bg-subtle-dark, and $theme-colors-border-subtle-dark for dark theme.

This is a manual process because Sass cannot generate its own Sass variables from an existing variable or map. In future versions, we’ll revisit this setup to reduce the duplication.

        
            
      // Required
      @import "functions";
      @import "variables";
      @import "variables-dark";
      
      // Add a custom color to $theme-colors
      $custom-colors: (
        "custom-color": #712cf9
      );
      $theme-colors: map-merge($theme-colors, $custom-colors);
      
      @import "maps";
      @import "mixins";
      @import "utilities";
      
      // Add a custom color to new theme maps
      
      // Light mode
      $custom-colors-text: ("custom-color": #712cf9);
      $custom-colors-bg-subtle: ("custom-color": #e1d2fe);
      $custom-colors-border-subtle: ("custom-color": #bfa1fc);
      
      $theme-colors-text: map-merge($theme-colors-text, $custom-colors-text);
      $theme-colors-bg-subtle: map-merge($theme-colors-bg-subtle, $custom-colors-bg-subtle);
      $theme-colors-border-subtle: map-merge($theme-colors-border-subtle, $custom-colors-border-subtle);
      
      // Dark mode
      $custom-colors-text-dark: ("custom-color": #e1d2f2);
      $custom-colors-bg-subtle-dark: ("custom-color": #8951fa);
      $custom-colors-border-subtle-dark: ("custom-color": #e1d2f2);
      
      $theme-colors-text-dark: map-merge($theme-colors-text-dark, $custom-colors-text-dark);
      $theme-colors-bg-subtle-dark: map-merge($theme-colors-bg-subtle-dark, $custom-colors-bg-subtle-dark);
      $theme-colors-border-subtle-dark: map-merge($theme-colors-border-subtle-dark, $custom-colors-border-subtle-dark);
      
      // Remainder of MDB imports
      ...
      
        
    

GET

UP TO 98% OFF

Check out our bundles and get up to 98% off PRO components.

Color modes - API


CSS variables

Dozens of root level CSS variables are repeated as overrides for dark mode. These are scoped to the color mode selector, which defaults to data-mdb-theme but can be configured to use a prefers-color-scheme media query. Use these variables as a guideline for generating your own new color modes.

        
            
        --#{$prefix}body-color: #{$body-color-dark};
        --#{$prefix}body-color-rgb: #{to-rgb($body-color-dark)};
        --#{$prefix}body-bg: #{$body-bg-dark};
        --#{$prefix}body-bg-rgb: #{to-rgb($body-bg-dark)};
    
        --#{$prefix}emphasis-color: #{$body-emphasis-color-dark};
        --#{$prefix}emphasis-color-rgb: #{to-rgb($body-emphasis-color-dark)};
    
        --#{$prefix}secondary-color: #{$body-secondary-color-dark};
        --#{$prefix}secondary-color-rgb: #{to-rgb($body-secondary-color-dark)};
        --#{$prefix}secondary-bg: #{$body-secondary-bg-dark};
        --#{$prefix}secondary-bg-rgb: #{to-rgb($body-secondary-bg-dark)};
    
        --#{$prefix}tertiary-color: #{$body-tertiary-color-dark};
        --#{$prefix}tertiary-color-rgb: #{to-rgb($body-tertiary-color-dark)};
        --#{$prefix}tertiary-bg: #{$body-tertiary-bg-dark};
        --#{$prefix}tertiary-bg-rgb: #{to-rgb($body-tertiary-bg-dark)};
    
        @each $color, $value in $theme-colors-text-dark {
          --#{$prefix}#{$color}-text-emphasis: #{$value};
        }
    
        @each $color, $value in $theme-colors-bg-subtle-dark {
          --#{$prefix}#{$color}-bg-subtle: #{$value};
        }
    
        @each $color, $value in $theme-colors-border-subtle-dark {
          --#{$prefix}#{$color}-border-subtle: #{$value};
        }
    
        --#{$prefix}heading-color: #{$headings-color-dark};
    
        --#{$prefix}link-color: #{$link-color-dark};
        --#{$prefix}link-hover-color: #{$link-hover-color-dark};
        --#{$prefix}link-color-rgb: #{to-rgb($link-color-dark)};
        --#{$prefix}link-hover-color-rgb: #{to-rgb($link-hover-color-dark)};
    
        --#{$prefix}code-color: #{$code-color-dark};
    
        --#{$prefix}border-color: #{$border-color-dark};
        --#{$prefix}border-color-translucent: #{$border-color-translucent-dark};
    
        --#{$prefix}form-valid-color: #{$form-valid-color-dark};
        --#{$prefix}form-valid-border-color: #{$form-valid-border-color-dark};
        --#{$prefix}form-invalid-color: #{$form-invalid-color-dark};
        --#{$prefix}form-invalid-border-color: #{$form-invalid-border-color-dark};


        --#{$prefix}surface-color: #{$surface-color-dark};
        --#{$prefix}surface-color-rgb: #{to-rgb($surface-color-dark)};
        --#{$prefix}surface-bg: #{$surface-bg-dark};
        --#{$prefix}surface-inverted-color: #{$surface-inverted-color-dark};
        --#{$prefix}surface-inverted-color-rgb: #{to-rgb($surface-inverted-color-dark)};
        --#{$prefix}surface-inverted-bg: #{$surface-inverted-bg-dark};
        --#{$prefix}divider-color: #{$divider-color-dark};
        --#{$prefix}highlight-bg-color: #{$highlight-bg-color-dark};
        --#{$prefix}scrollbar-rail-bg: #{$scrollbar-rail-bg-dark};
        --#{$prefix}scrollbar-thumb-bg: #{$scrollbar-thumb-bg-dark};
        --#{$prefix}picker-header-bg: #{$picker-header-bg-dark};
        --#{$prefix}timepicker-clock-face-bg: #{$timepicker-clock-face-bg-dark};
        --#{$prefix}sidenav-backdrop-opacity: #{$sidenav-backdrop-opacity-dark};
        --#{$prefix}form-control-border-color: #{$form-control-border-color-dark};
        --#{$prefix}form-control-label-color: #{$form-control-label-color-dark};
        --#{$prefix}form-control-disabled-bg: #{$form-control-disabled-bg-dark};
        --#{$prefix}box-shadow-color: #{$box-shadow-color-dark};
        --#{$prefix}box-shadow-color-rgb: #{to-rgb($box-shadow-color-dark)};
        --#{$prefix}stepper-mobile-bg: #{$stepper-mobile-bg-dark};
        
        
        
    

SCSS variables

        
            

        $primary-text-emphasis-dark: tint-color($primary, 20%) !default;
        $secondary-text-emphasis-dark: tint-color($secondary, 60%) !default;
        $success-text-emphasis-dark: tint-color($success, 40%) !default;
        $info-text-emphasis-dark: tint-color($info, 30%) !default;
        $warning-text-emphasis-dark: tint-color($warning, 40%) !default;
        $danger-text-emphasis-dark: tint-color($danger, 20%) !default;
        $light-text-emphasis-dark: $gray-100 !default;
        $dark-text-emphasis-dark: $gray-200 !default;

        $primary-bg-subtle-dark: shade-color($primary, 80%) !default;
        $secondary-bg-subtle-dark: shade-color($secondary, 80%) !default;
        $success-bg-subtle-dark: shade-color($success, 80%) !default;
        $info-bg-subtle-dark: shade-color($info, 80%) !default;
        $warning-bg-subtle-dark: shade-color($warning, 80%) !default;
        $danger-bg-subtle-dark: shade-color($danger, 80%) !default;
        $light-bg-subtle-dark: $gray-800 !default;
        $dark-bg-subtle-dark: $gray-900 !default;

        $primary-border-subtle-dark: shade-color($primary, 40%) !default;
        $secondary-border-subtle-dark: shade-color($secondary, 40%) !default;
        $success-border-subtle-dark: shade-color($success, 40%) !default;
        $info-border-subtle-dark: shade-color($info, 40%) !default;
        $warning-border-subtle-dark: shade-color($warning, 40%) !default;
        $danger-border-subtle-dark: shade-color($danger, 40%) !default;
        $light-border-subtle-dark: $gray-700 !default;
        $dark-border-subtle-dark: $gray-800 !default;

        $body-color-dark: $white !default;
        $body-bg-dark: #303030 !default;
        $body-secondary-bg-dark: $gray-200 !default;
        $border-color-dark: rgba(255, 255, 255, 0.12) !default;
        $border-color-translucent-dark: rgba($white, 0.15) !default;

        $surface-color-dark: $white !default;
        $surface-bg-dark: #424242 !default;
        $surface-inverted-color-dark: $white !default;
        $surface-inverted-bg-dark: #757575 !default;
        $divider-color-dark: rgba(255, 255, 255, 0.12) !default;
        $highlight-bg-color-dark: rgba(255, 255, 255, 0.3) !default;
        $scrollbar-rail-bg-dark: $gray-500 !default;
        $scrollbar-thumb-bg-dark: $gray-200 !default;
        $picker-header-bg-dark: #323232 !default;
        $timepicker-clock-face-bg-dark: $gray-700 !default;
        $sidenav-backdrop-opacity-dark: 0.5 !default;
        $form-control-border-color-dark: rgba(255, 255, 255, 0.7) !default;
        $form-control-label-color-dark: $gray-400 !default;
        $form-control-disabled-bg-dark: $gray-700 !default;
        $box-shadow-color-dark: $black !default;
        $stepper-mobile-bg-dark: $gray-800 !default;

        // Accordion

        $accordion-icon-color-dark: $surface-color-dark !default;
        $accordion-icon-active-color-dark: $primary !default;

        
        
    

Sass mixins

Styles for dark mode, and any custom color modes you create, can be scoped appropriately to the data-mdb-theme attribute selector or media query with the customizable color-mode() mixin. See the Sass usage section in the Overview tab for more details.

        
            

          @mixin color-mode($mode: light, $root: false) {
            @if $color-mode-type == 'media-query' {
              @if $root == true {
                @media (prefers-color-scheme: $mode) {
                  :root {
                    @content;
                  }
                }
              } @else {
                @media (prefers-color-scheme: $mode) {
                  @content;
                }
              }
            } @else {
              [data-mdb-theme='#{$mode}'] {
                @content;
              }
            }
          }